Index: /Interface_Web/trunk/pspaWT/sources/controler/src/softwareMadx.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/src/softwareMadx.cc	(revision 431)
+++ /Interface_Web/trunk/pspaWT/sources/controler/src/softwareMadx.cc	(revision 431)
@@ -0,0 +1,144 @@
+
+#include "softwareMadx.h"
+#include "dataManager.h"
+
+softwareMadx::softwareMadx() : abstractSoftware()
+{
+  nameOfSoftware_ = nomDeLogiciel("madx");
+}
+
+softwareMadx::softwareMadx(string inputFileName,sectorParameters* lattice,dataManager* dt) : abstractSoftware(inputFileName,lattice,dt)
+{
+  nameOfSoftware_ = nomDeLogiciel("madx");
+
+  registerElement(nomdElements::drift,TBoolOk);
+  registerElement(nomdElements::mpole,TBoolOk);
+}
+
+bool softwareMadx::createInputFile(particleBeam* beamBefore,unsigned int numeroDeb,unsigned int numeroFin,string workingDir)
+{
+  cout << "***********************************" << endl;
+  cout << " softwareMadx::createInputFile(...) " << endl << endl;
+
+  dataManager_->consoleMessage(" softwareMadx::createInputFile");
+  if (!initComputationLimits(numeroDeb,numeroFin)) return false;
+
+  string name = workingDir + inputFileName_;
+  ofstream outfile;
+  outfile.open(name.c_str(),ios::out);
+  if(!outfile) {
+    dataManager_->consoleMessage(" softwareMadx::createInputFile : error opening output stream ");
+    cerr << " error opening output stream " << name << endl;
+    return false;
+  }
+  
+  outfile << endl; // saut de ligne
+  ostringstream os;
+  os << "L: " << "line=(";
+
+  abstractElement* elPtr;
+  for(unsigned k = numeroDeb_; k <= numeroFin_; k++)
+    {
+      elPtr = dataManager_->getElementPointerFromNumero(k);
+      cout << "debug:: element [" << k << "] " << elPtr->getNomdElement().getExpandedName() << endl;
+      vector<statements> v= elPtr->parametersToSoftware();
+      string label= v.at(0).second.at(1);
+      outfile << inputFormat(v); //<< endl;
+      os << label <<",";
+    }//k;
+
+  os << ");" << endl;
+  int nCells= sectParamPtr_->getNumberOfCells();
+  os << "all: line=(" << nCells << "*L);" << endl;
+  outfile << endl; // saut de ligne
+  outfile << os.str() << endl; // beam line definition p34
+
+  outfile << "beam;" << endl; // beam data p46
+  outfile << "use, period = all;" << endl << endl; // action commands p45
+  
+  outfile << "select,flag = twiss,column = name,s,betx,bety;" << endl; //p48
+  outfile << "twiss,save,centre,file = twiss.out;" << endl; //p51
+  outfile << "stop;" << endl;
+
+  outfile.close();
+  dataManager_->consoleMessage("input file done for madx");
+  return true;
+}
+
+string softwareMadx::inputFormat(const vector<statements>& v) const 
+{
+  // v.at(0).first = "labelsGenericSpecific"
+  // v.at(0).second = vector<string> de 2 elements (type de l'element,label)
+  string keyword= v.at(0).second.at(0);
+  string label= v.at(0).second.at(1);
+  ostringstream os;
+  if(keyword == "drift") {
+    double length = atof(v.at(1).second.at(0).c_str());
+    os << label << ":" << " drift, l=" << 0.01*length<< ";" << endl;
+
+  } else if(keyword == "mpole") {
+    double x[9]= {0.0}; // 0 <= n <= 9 in user's manual of MAD program  
+    int n= atoi(v.at(1).second.at(0).c_str());
+    x[n]= atof(v.at(1).second.at(1).c_str());
+    os << label << ":" << " multipole, knl={" << x[0];
+    for(int i = 1; i <= n; i++) {
+      os << "," << x[i];
+    }
+    os <<"};" << endl;
+    
+  } else {
+    cout << "softwareMadx::inputFormat ERROR : element type= " << keyword << " not defined" << endl;
+  }
+  
+  return os.str();
+}
+
+bool softwareMadx::execute(string workingDir)
+{
+  cout << "***********************************" << endl;
+  cout << " softwareMadx::execute(...) " << endl << endl;
+
+  dataManager_->consoleMessage(" softwareMadx::execute");
+  bool status= true;
+
+  ostringstream sortie;
+  sortie << " run madx from " << numeroDeb_ << " to " << numeroFin_ << endl;
+
+  string mjob = workingDir + "madx64";
+  mjob += string(" <  ");
+  mjob += workingDir + inputFileName_;
+  cout << " job madx = " << mjob << endl;
+  
+  string resultOfRun;
+  bool success = launchJob(mjob,resultOfRun);
+  // xx sortie << resultOfRun << endl;
+  if ( !success ) {
+    //sortie << " launching of madx failed " << endl;
+    status = false;
+  } else {
+    sortie << " madx finished normally" << endl;
+    string nameOut = workingDir + "madx.output";
+    ofstream outfile;
+    outfile.open(nameOut.c_str(),ios::out);
+    if (!outfile) {
+      sortie << " error in opening madx output stream " << nameOut << endl;
+      status = false;
+    } else {
+      // on copie la sortie dans un fichier 'madx.out'
+      outfile << resultOfRun << endl;
+      outfile.close();
+    }
+  }
+
+  dataManager_->consoleMessage(sortie.str());
+  return status;
+}
+
+bool softwareMadx::buildBeamAfterElements(string workingDir)
+{
+  cout << "***********************************" << endl;
+  cout << " softwareMadx::buildBeamAfterElements(...) " << endl << endl;
+
+  dataManager_->consoleMessage(" softwareMadx::buildBeamAfterElements");
+  return false;
+}
Index: /Interface_Web/trunk/pspaWT/sources/controler/src/softwareUnknown.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/src/softwareUnknown.cc	(revision 431)
+++ /Interface_Web/trunk/pspaWT/sources/controler/src/softwareUnknown.cc	(revision 431)
@@ -0,0 +1,33 @@
+
+#include "softwareUnknown.h"
+
+softwareUnknown::softwareUnknown() : abstractSoftware()
+{
+   nameOfSoftware_ = nomDeLogiciel("unknownSoftware");
+
+   registerElement(nomdElements::beam,TBoolIgnore);
+   registerElement(nomdElements::RFgun,TBoolIgnore);
+   registerElement(nomdElements::drift,TBoolIgnore);
+   registerElement(nomdElements::cell,TBoolIgnore);
+   registerElement(nomdElements::bend,TBoolIgnore);
+   registerElement(nomdElements::soleno,TBoolIgnore);
+   registerElement(nomdElements::fit,TBoolIgnore);
+   registerElement(nomdElements::snapshot,TBoolIgnore);
+   registerElement(nomdElements::mpole,TBoolIgnore);
+}
+
+bool softwareUnknown::createInputFile(particleBeam* beamBefore,unsigned int numeroDeb,unsigned int numeroFin,string workingDir)
+{
+  return true;
+}
+
+bool softwareUnknown::execute(string workingDir)
+{
+  return true;
+}
+
+bool softwareUnknown::buildBeamAfterElements(string workingDir)
+{
+  return true;
+}
+
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_abstractElement.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_abstractElement.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_abstractElement.h	(revision 431)
@@ -3,6 +3,7 @@
 
 #include "GWt_draggableImage.h"
+#include "GWt_console.h"
+
 #include "abstractElement.h"
-#include "GWt_console.h"
 #include "elementDrift.h"
 #include "elementRfgun.h"
@@ -13,4 +14,5 @@
 #include "elementFit.h"
 #include "elementSnapshot.h"
+#include "elementMultipole.h"
 
 #include <Wt/WDialog>
@@ -33,49 +35,47 @@
 class GWt_abstractElement : public WContainerWidget
 {
-    protected :
+ protected :
     
-    abstractElement* abstractElement_;
+  abstractElement* abstractElement_;
     
-    WDialog* dialog_;
-    GWt_draggableImage* dropped_;
-    WContainerWidget* wc_;
-    WText* wc_item_;
-    WLineEdit* labelEdit_;
+  WDialog* dialog_;
+  GWt_draggableImage* dropped_;
+  WContainerWidget* wc_;
+  WText* wc_item_;
+  WLineEdit* labelEdit_;
     
-    GWt_abstractElement() {;}
-    string* beginDialog();
-    
-    public :
-    
-    GWt_abstractElement(abstractElement*);
-    
-    void initialize();
-    void showParameters();
-    void deleteElement();
+  GWt_abstractElement() {;}
+  string* beginDialog();
+  
+ public :
+  
+  GWt_abstractElement(abstractElement*);
+  
+  void initialize();
+  void showParameters();
+  void deleteElement();
+  
+  void updateLabelAndToolTipWidget();
+  void FileInput(ifstream& ifs);
+  
+  WContainerWidget* getWidget();
+  abstractElement* getAbstractElement();
 
-    void updateLabelAndToolTipWidget();
-    void FileInput(ifstream& ifs);
-    
-    //  GWt_draggableImage* getImage();
-    WContainerWidget* getWidget();
-    abstractElement* getAbstractElement();
-    
-    virtual void dialogDone(WDialog::DialogCode code) = 0;
-    
-    inline WString print() {
-        return abstractElement_->print();
-    }
-    
-    virtual string getMimeType() = 0;
-    virtual string getSmallImageURL() = 0;
-    virtual string getBigImageURL() = 0;
-    virtual string getName() = 0;
-    virtual void initilializeDialog() = 0;
-    
-    void createDragImage(WContainerWidget*);
-    WImage* getImage();
-    
-protected:
-    
+  inline WString print() {
+    return abstractElement_->print();
+  }
+
+  virtual void dialogDone(WDialog::DialogCode code) = 0; 
+  virtual string getMimeType() = 0;
+  virtual string getSmallImageURL() = 0;
+  virtual string getBigImageURL() = 0;
+  virtual string getName() = 0;
+  virtual void initilializeDialog() = 0;
+  
+  void createDragImage(WContainerWidget*);
+  WImage* getImage();
+  
+ protected:
+  
     WImage* image_;
     GWt_elementLigneFaisceau* elementLigneFaiseauContainer_;
@@ -86,10 +86,10 @@
     
     inline void registerParam(string name, variant<int, string, bool, float, NullType> value, string desc) {
-        parameterMapValue[name] = value;
-        parameterMapDescription[name] = desc;
+      parameterMapValue[name] = value;
+      parameterMapDescription[name] = desc;
     }
     
-    variant<int, string, bool, float, NullType> getParamValue(string elem);
-    string getParamDescription(string elem);
+    variant<int, string, bool, float, NullType> getParamValue(string);
+    string getParamDescription(string);
 };
 #endif
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_abstractElementFactory.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_abstractElementFactory.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_abstractElementFactory.h	(revision 431)
@@ -18,4 +18,5 @@
 #include "GWt_fit.h"
 #include "GWt_snapshot.h"
+#include "GWt_mpole.h"
 
 using namespace Wt;
@@ -62,4 +63,8 @@
   inline void setSnapshotEnable(bool a) { isSnapshotElementEnable = a;};
   
+  /* Enable the mpole element creation
+   */
+  inline void setMPoleEnable(bool a) { isMPoleElementEnable = a;};
+  
   GWt_drift* createDriftElement();
   GWt_rfgun* createRFGunElement();
@@ -70,4 +75,5 @@
   GWt_fit* createFitElement();
   GWt_snapshot* createSnapshotElement();
+  GWt_mpole* createMPoleElement();
   vector <GWt_abstractElement*> getAllElements();
   
@@ -82,4 +88,5 @@
   bool isFitElementEnable;
   bool isSnapshotElementEnable;
+  bool isMPoleElementEnable;
 };
 #endif
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_globalParameters.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_globalParameters.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_globalParameters.h	(revision 431)
@@ -39,5 +39,5 @@
   void updateGlobals();
   void renew();
-  void setText(WContainerWidget*);
+  void setText(WText*);
 };
 #endif
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_mpole.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_mpole.h	(revision 431)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_mpole.h	(revision 431)
@@ -0,0 +1,37 @@
+#ifndef GRAPHMPOLEELEMENT_SEEN
+#define GRAPHMPOLEELEMENT_SEEN
+
+#include "GWt_abstractElement.h"
+#include "abstractElement.h"
+
+#include <iostream>
+#include <string>
+#include <sstream>
+
+using namespace Wt;
+using namespace std;
+
+class GWt_mpole : public GWt_abstractElement
+{
+  WLineEdit* orderEdit_;
+  WLineEdit* componentEdit_;
+
+ public :
+  
+  GWt_mpole()  {;}
+  GWt_mpole(GWt_elementLigneFaisceau*);
+  ~GWt_mpole() {;}
+  
+  virtual void dialogDone(WDialog::DialogCode code);
+  WImage* getImage();
+    
+  inline string getMimeType() {return "htdocs/mpole.jpg";}
+  inline string getSmallImageURL() {return "htdocs/mpole.jpg";}
+  inline string getBigImageURL() {return "htdocs/mpole.jpg";}
+  inline string getName() {return "mpole";}
+  
+ private :
+
+  void initilializeDialog();
+};
+#endif
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_pspaApplication.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_pspaApplication.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_pspaApplication.h	(revision 431)
@@ -3,5 +3,6 @@
 
 #include <cstdlib>
-#include <list>
+#include <string.h>
+#include <vector>
 
 #include <Wt/WApplication>
@@ -9,4 +10,5 @@
 #include <Wt/WContainerWidget>
 #include <Wt/WText>
+#include <Wt/WLineEdit>
 #include <Wt/WPanel>
 #include <Wt/WComboBox>
@@ -24,4 +26,5 @@
 #include "GWt_ligneFaisceau.h"
 #include "GWt_globalParameters.h"
+#include "GWt_sectorParameters.h"
 
 #include "dataManager.h"
@@ -43,6 +46,6 @@
   GWt_LigneFaisceau* beamLine_;
     
-  // WWidget* globalParam_;
-  GWt_globalParameters* globalParam_; // xx
+  GWt_globalParameters* globalParam_;
+  GWt_sectorParameters* sectorParam_;
   
   GWt_dialog* graphicsDialog_;
@@ -73,8 +76,7 @@
   WContainerWidget* createDrawingWidget();
 
-  //WWidget* createGlobalParamWidget();
-  WWidget* createDashBoard(); // xx
-  void messageBox1(); // xx
-  void messageBox2(); // xx
+  WWidget* createDashBoard();
+  void messageBox1();
+  void messageBox2();
   
   // extensions (.001, .002,...) pour les fichiers "snapshot" 
@@ -119,9 +121,4 @@
   }
 
-
-  /* inline WWidget* getGlobalParam() { */
-  /*   return globalParam_; */
-  /* } */
-
   inline GWt_softwarePanel* getExecuteWidget() {
     return executeWidget_;
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_sectorParameters.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_sectorParameters.h	(revision 431)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_sectorParameters.h	(revision 431)
@@ -0,0 +1,42 @@
+#ifndef GWT_SECTORPARAMETERS_SEEN
+#define GWT_SECTORPARAMETERS_SEEN
+
+#include <string>
+#include <Wt/WContainerWidget>
+#include <Wt/WLineEdit>
+#include <Wt/WDialog>
+#include <Wt/WText>
+
+using namespace Wt;
+using namespace std;
+
+class dataManager;
+
+class GWt_sectorParameters : public WContainerWidget
+{
+  WLineEdit* geometry_;
+  WLineEdit* nCells_;
+  WLineEdit* lCell_;
+  WLineEdit* pc_;
+
+  dataManager* dt_;
+  WText *status_;
+  WDialog *dialog_;
+  string envoi_[5];
+
+  string* getSectorParameters();
+  void setStatus();
+
+ public :
+  
+  GWt_sectorParameters() {;}
+  GWt_sectorParameters(dataManager*);
+  virtual ~GWt_sectorParameters() {;}
+
+  void execDialog();
+  void dialogDone(WDialog::DialogCode code);
+  void update();
+  void renew();
+  void setText(WText*);
+};
+#endif
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_softwarePanel.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_softwarePanel.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/include/GWt_softwarePanel.h	(revision 431)
@@ -23,30 +23,29 @@
 class GWt_softwarePanel  : public WContainerWidget
 {
-    public :
-    GWt_softwarePanel(dataManager*, PspaApplication*);
-    virtual ~GWt_softwarePanel();
+ public :
+  
+  GWt_softwarePanel(dataManager*, PspaApplication*);
+  virtual ~GWt_softwarePanel();
 
-    void addSectionToExecuteW();
-    void updateSections();
+  void addSectionToExecuteW();
+  void updateSections();
     
-    private :
-    //    void disableSectionExecute();
-    //    void checkSectionSelection();
-    bool updateSectionSelection();
-    void deleteSectionToExecuteW(int section);
-    string getSelection();
-    void executer();
-    bool areDataCoherent();
-    void fillComboWithElements(Wt::WComboBox* cBox);
-    void fillComboWithSoftwares(Wt::WComboBox* cBox);
-    Wt::WContainerWidget* createAddDeletePushButtons(int sectionIndex);
+ private :
+ 
+  bool updateSectionSelection();
+  void deleteSectionToExecuteW(int section);
+  string getSelection();
+  void executer();
+  bool areDataCoherent();
+  void fillComboWithElements(Wt::WComboBox* cBox);
+  void fillComboWithSoftwares(Wt::WComboBox* cBox);
+  Wt::WContainerWidget* createAddDeletePushButtons(int sectionIndex);
 
-    dataManager* dtmanage_;
-    WPushButton *exec_go_;
-    WContainerWidget* contenuSections_;
-    PspaApplication* pspa_;
+  dataManager* dtmanage_;
+  WPushButton *exec_go_;
+  WContainerWidget* contenuSections_;
+  PspaApplication* pspa_;
 
-    std::vector <GWt_sectionToExecute*> sections_;
+  std::vector <GWt_sectionToExecute*> sections_;
 };
-
 #endif /* defined(__PSPA__GWt_softwarePanel__) */
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_abstractElement.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_abstractElement.cc	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_abstractElement.cc	(revision 431)
@@ -14,5 +14,6 @@
 #include "GWt_beam.h"
 #include "GWt_fit.h"
-#include "GWt_snapshot.h"
+//#include "GWt_snapshot.h"
+
 #include "GWt_draggableImage.h"
 #include "GWt_ligneFaisceau.h"
@@ -29,58 +30,48 @@
 
 GWt_abstractElement::GWt_abstractElement(abstractElement* elem)
-: WContainerWidget()
+  : WContainerWidget()
 {
-    abstractElement_ = elem;
+  abstractElement_ = elem;
 }
-
 
 void GWt_abstractElement::initialize()
 {
-    // make image
-    image_ = new WImage(getBigImageURL(),this);
-    
-    addWidget(image_);
-    updateLabelAndToolTipWidget();
+  image_ = new WImage(getBigImageURL(),this); // make image  
+  addWidget(image_);
+  updateLabelAndToolTipWidget();
 }
-
 
 string* GWt_abstractElement::beginDialog()
 {
-  string* param = abstractElement_-> getParametersString();
-    
-  if ( param == NULL )
-    {
-      if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
-	GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
-	console->addConsoleMessage(" GWt_abstractElement::beginDialog : empty parameter set for element " + abstractElement_->getNomdElement().getExpandedName());
-        }
+  string* param = abstractElement_->getParametersString();
+  
+  if ( param == NULL ) {
+    if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
+      GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
+      console->addConsoleMessage(" GWt_abstractElement::beginDialog : empty parameter set for element " + abstractElement_->getNomdElement().getExpandedName());
     }
-  //   int compteur = -1;
+  }
+
+  int nbparam = atoi(param->c_str());
+  if ( nbparam != abstractElement_->getNbParams()) {
+    if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
+      GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
+      console->addConsoleMessage(" element seems not to be a " + abstractElement_->getNomdElement().getExpandedName());
+    }
+  }
   
-  //  int nbparam = atoi(param[++compteur].c_str());
-  int nbparam = atoi(param->c_str());
-  if ( nbparam != abstractElement_->getNbParams())
-    {
-        if ( static_cast<GWt_console*> (wApp->findWidget ("console"))) {
-	  GWt_console* console = static_cast<GWt_console*> (wApp->findWidget ("console"));
-	  console->addConsoleMessage(" element seems not to be a " + abstractElement_->getNomdElement().getExpandedName());
-        }
-    }
-  
-  dialog_ = new WDialog("element " + abstractElement_->getNomdElement().getExpandedName());
-    new WText(" label of the element : ",dialog_->contents());
-    //  labelEdit_ = new WLineEdit(param[++compteur].c_str(), dialog_->contents());
-    
-    labelEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
-    new WBreak(dialog_->contents());
-    return ++param;
+  dialog_ = new WDialog("element "+abstractElement_->getNomdElement().getExpandedName());
+  new WText(" label of the element : ",dialog_->contents());
+  labelEdit_ = new WLineEdit( (++param)->c_str(),dialog_->contents());
+  new WBreak(dialog_->contents());
+  return ++param;
 }
 
 void GWt_abstractElement::updateLabelAndToolTipWidget()
 {
-    if (abstractElement_ != NULL) {
+  if (abstractElement_ != NULL) {
     elementLigneFaiseauContainer_->setElementLabel(abstractElement_->getLabel());
     setToolTip(print());
-    }
+  }
 }
 
@@ -91,116 +82,105 @@
 }
 
-
 void GWt_abstractElement::deleteElement()
 {
-    StandardButton result = WMessageBox::show("PSPA : Delete element", WString("Delete '")+WString(getAbstractElement()->getLabel())+"' ?", Ok | Cancel);
+  StandardButton result = WMessageBox::show("PSPA : Delete element", WString("Delete '")+WString(getAbstractElement()->getLabel())+"' ?", Ok | Cancel);
+  
+  if (result == Cancel) {
+    return;
+  }
+  // get LigneFaiseau widget and add new elementLigneFaiseau
+  GWt_LigneFaisceau* ligneFaisceau = NULL;
+  if ( static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"))) {
+    ligneFaisceau = static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"));
+  } else {
+    return;
+  }
+  
+  ligneFaisceau->removeElement(this);
+}
 
-    if (result == Cancel ) {
-        return;
-    }
-    // get LigneFaiseau widget and add new elementLigneFaiseau
-    GWt_LigneFaisceau* ligneFaisceau = NULL;
-    if ( static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"))) {
-        ligneFaisceau = static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"));
-    } else {
-        return;
-    }
-    
-    ligneFaisceau->removeElement(this);
+void GWt_abstractElement::createDragImage(WContainerWidget* w)
+{
+  GWt_draggableImage *result= new GWt_draggableImage(getBigImageURL(),w);
+  
+  /*
+   * Set the image to be draggable, showing the other image (dragImage)
+   * to be used as the widget that is visually dragged.
+   */
+  result->setDraggable(getMimeType(),new WImage(getSmallImageURL(),w),true);
+  result->setToolTip(getName());
+}
+
+void GWt_abstractElement::FileInput(ifstream& ifs)
+{
+  getAbstractElement()->FileInput(ifs);
+  initilializeDialog();
+  updateLabelAndToolTipWidget();
+  
+  // update parameters
+  GWt_LigneFaisceau* ligneFaisceau = NULL;
+  if ( static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"))) {
+    ligneFaisceau = static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"));
+    ligneFaisceau->update();
+  }
+}
+
+abstractElement* GWt_abstractElement::getAbstractElement() {
+  return abstractElement_;
 }
 
 WContainerWidget* GWt_abstractElement::getWidget() {
-    return wc_;
-}
-
-abstractElement* GWt_abstractElement::getAbstractElement() {
-    return abstractElement_;
-}
-
-
-void GWt_abstractElement::createDragImage(WContainerWidget* w){
-
-    GWt_draggableImage *result = new GWt_draggableImage(getBigImageURL(),w);
-
-    /*
-     * Set the image to be draggable, showing the other image (dragImage)
-     * to be used as the widget that is visually dragged.
-     */
-    result->setDraggable(getMimeType(),new WImage(getSmallImageURL(),w),true);
-    result->setToolTip(getName());
-
+  return wc_;
 }
 
 WImage* GWt_abstractElement::getImage() {
-    return image_;
+  return image_;
 }
 
-
-void GWt_abstractElement::FileInput(ifstream& ifs){
-    getAbstractElement()->FileInput(ifs);
-    initilializeDialog();
-    updateLabelAndToolTipWidget();
-
-// update parameters
-    GWt_LigneFaisceau* ligneFaisceau = NULL;
-    if ( static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"))) {
-        ligneFaisceau = static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"));
-        ligneFaisceau->update();
+variant<int, string, bool, float, NullType> GWt_abstractElement::getParamValue(string elem) 
+{
+  if(parameterMapValue.find(elem) == parameterMapValue.end()) {
+    return new NullType();
+  }
+  
+  std::map<std::string, variant<int, string, bool, float, NullType> >::iterator it;
+  it = parameterMapValue.find(elem);
+  variant <int, string, bool, float, NullType> value = it->second;
+  
+  try {
+    int pi = boost::get<int>(value);
+    printf("%s Type is int\n",elem.c_str());
+    return pi;
+  }
+  catch (boost::bad_get v) {
+    try {
+      string si = boost::get<string>(value);
+      printf("%s Type is string\n",elem.c_str());
+      return si;
     }
+    catch (boost::bad_get v) {
+      try {
+	bool bi = boost::get<bool>(value);
+	printf("%s Type is bool\n",elem.c_str());
+	return bi;
+      }
+      catch (boost::bad_get v) {
+	printf("%s Type is NULL\n",elem.c_str());
+	return new NullType();
+      }
+    }
+  }
+  printf("%s Type is NULL NULL\n",elem.c_str());
+  return new NullType();
 }
 
-
-
-variant<int, string, bool, float, NullType> GWt_abstractElement::getParamValue(string elem) {
-
-    if (parameterMapValue.find(elem) == parameterMapValue.end() )
-    {
-        return new NullType();
-    }
-
-    std::map<std::string, variant<int, string, bool, float, NullType> >::iterator it;
-    it = parameterMapValue.find(elem);
-    
-    variant <int, string, bool, float, NullType> value = it->second;
-    
-    try {
-        int pi = boost::get<int>(value);
-        printf("%s Type is int\n",elem.c_str());
-        return pi;
-    }
-    catch (boost::bad_get v) {
-        try {
-            string si = boost::get<string>(value);
-            printf("%s Type is string\n",elem.c_str());
-            return si;
-        }
-        catch (boost::bad_get v) {
-            try {
-                bool bi = boost::get<bool>(value);
-                printf("%s Type is bool\n",elem.c_str());
-                return bi;
-            }
-            catch (boost::bad_get v) {
-                printf("%s Type is NULL\n",elem.c_str());
-                return new NullType();
-            }
-        }
-    }
-    printf("%s Type is NULL NULL\n",elem.c_str());
-    return new NullType();
+string GWt_abstractElement::getParamDescription(string elem)
+{    
+  if(parameterMapDescription.find(elem) == parameterMapDescription.end() ) {
+    printf("%s Descr is NULL NULL\n",elem.c_str());
+    return "";
+  } else {
+    printf("%s Descr is %s\n",elem.c_str(),parameterMapDescription.find(elem)->second.c_str());
+    return parameterMapDescription.find(elem)->second;
+  }
 }
-
-
-string GWt_abstractElement::getParamDescription(string elem) {
-    
-    if (parameterMapDescription.find(elem) == parameterMapDescription.end() )
-    {
-        printf("%s Descr is NULL NULL\n",elem.c_str());
-        return "";
-    } else {
-        printf("%s Descr is %s\n",elem.c_str(),parameterMapDescription.find(elem)->second.c_str());
-        return parameterMapDescription.find(elem)->second;
-    }
-}
-
-
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_abstractElementFactory.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_abstractElementFactory.cc	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_abstractElementFactory.cc	(revision 431)
@@ -17,5 +17,6 @@
   isBeamElementEnable(false),
   isFitElementEnable(false),
-  isSnapshotElementEnable(false)
+  isSnapshotElementEnable(false),
+  isMPoleElementEnable(false)
 {}
 
@@ -30,4 +31,5 @@
   isFitElementEnable = false;
   isSnapshotElementEnable = false;
+  isMPoleElementEnable = false;
 }
 
@@ -96,4 +98,12 @@
 }
 
+GWt_mpole* GWt_abstractElementFactory::createMPoleElement() 
+{
+  if (isMPoleElementEnable) {
+    return new GWt_mpole();
+  }
+  return NULL;
+}
+
 vector <GWt_abstractElement*> GWt_abstractElementFactory::getAllElements()
 {
@@ -123,4 +133,7 @@
     elems.push_back(new GWt_snapshot());
   }
+  if (isMPoleElementEnable) {
+    elems.push_back(new GWt_mpole());
+  }
 
   return elems;
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_elementLigneFaisceau.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_elementLigneFaisceau.cc	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_elementLigneFaisceau.cc	(revision 431)
@@ -13,4 +13,5 @@
 #include "GWt_fit.h"
 #include "GWt_snapshot.h"
+#include "GWt_mpole.h"
 
 
@@ -55,5 +56,5 @@
 void GWt_elementLigneFaisceau::initialize_ligneFaisceau(nomdElements::typedElement eType)
 {   
-  cout<<"new GWt_elementLigneFaisceau : "<< this << endl;
+  cout << " new GWt_elementLigneFaisceau : "<< nomdElements::getLabelFromType(eType) << endl;
     
   // set layout
@@ -113,4 +114,7 @@
   case nomdElements::fit  :
     GWt_abstractElement_ = new GWt_fit(this);
+    break;
+  case nomdElements::mpole  :
+    GWt_abstractElement_ = new GWt_mpole(this);
     break;
   case nomdElements::snapshot :
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_globalParameters.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_globalParameters.cc	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_globalParameters.cc	(revision 431)
@@ -15,7 +15,7 @@
 }
 
-void GWt_globalParameters::setText(WContainerWidget* wt)
+void GWt_globalParameters::setText(WText *st)
 {
-  status_ = new WText("Go ahead...",wt);
+  status_ = st;
 }
 
@@ -105,8 +105,8 @@
 void GWt_globalParameters::setStatus()
 {
-  WString out= WString("<p>frequency="+envoi_[1]+"</p>"
-	               "<p>step in phase="+envoi_[2]+"</p>"
-  	               "<p>max step number="+envoi_[3]+"</p>"
-   	               "<p>periodicity of s.c. computation="+envoi_[4]+"</p>");
+  WString out= WString("<p>frequency = "+envoi_[1]+"</p>"
+	               "<p>step in phase = "+envoi_[2]+"</p>"
+  	               "<p>max step number = "+envoi_[3]+"</p>"
+   	               "<p>periodicity of s.c. computation = "+envoi_[4]+"</p>");
   status_->setText(out);
 }
Index: /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_ligneFaisceau.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_ligneFaisceau.cc	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/userInterface/src/GWt_ligneFaisceau.cc	(revision 431)
@@ -59,5 +59,5 @@
 
   GWt_abstractElement* GWtAbstractElem = NULL;  
-  cout << " Entree addElement element " << nomdElements::getLabelFromType(eType) << endl;
+  cout << " addElement::element : " << nomdElements::getLabelFromType(eType) << endl;
     
   // 3 cases :
@@ -288,12 +288,13 @@
 
 
-void GWt_LigneFaisceau::initializeSoftwares(){
-    
+void GWt_LigneFaisceau::initializeSoftwares()
+{    
   vector <abstractElement*> elems = getAllAbstractElements();
-    for (int a=0; a< elems.size(); a++) {
-      //     elems[a]->setSoftware(nomDeLogiciel::unknownSoftware);
-      elems[a]->setSoftware( NULL );
-    }
-}
-
-
+  cout << "GWt_LigneFaisceau::initializeSoftwares() " << elems.size() << endl;
+
+  for (int a = 0; a < elems.size(); a++) {
+    elems[a]->setSoftware( NULL );
+  }
+}
+
+
